#include "misc.h"

void font_init()
{
    unsigned short * tex;

    font_tex = ta->txr_allocate(512*512*2);
    bin_to_texture(FONT_FILE, font_tex, 512, 512);
}

void draw_char(float x1, float y1, float z1, float a, float r, float g, float b, int c, float xs, float ys) {
    vertex_ot_t     vert;
    int             ix, iy;
    float           u1, v1, u2, v2;
    
    ix = (c % 16) * 32;
    iy = (c / 16) * 48;
    u1 = ((float)(ix)+ 0.5f) / 512.0f;
    v1 = ((float)(iy) + 0.5f) / 512.0f;
    u2 = (ix+32) / 512.0f;
    v2 = (iy+48) / 512.0f;
    
    vert.flags = TA_VERTEX_NORMAL;
    vert.x = x1;
    vert.y = y1 + 48.0f * ys;
    vert.z = z1;
    vert.u = u1;
    vert.v = v2;
    vert.dummy1 = vert.dummy2 = 0;
    vert.a = a;
    vert.r = r;
    vert.g = g;
    vert.b = b;
    vert.oa = vert.or = vert.og = vert.ob = 0.0f;
    ta->commit_vertex(&vert, sizeof(vert));
    
    vert.x = x1;
    vert.y = y1;
    vert.u = u1;
    vert.v = v1;
    ta->commit_vertex(&vert, sizeof(vert));
    
    vert.x = x1 + 32.0f * xs;
    vert.y = y1 + 48.0f * ys;
    vert.u = u2;
    vert.v = v2;
    ta->commit_vertex(&vert, sizeof(vert));
    
    vert.flags = TA_VERTEX_EOL;
    vert.x = x1 + 32.0f * xs;
    vert.y = y1;
    vert.u = u2;
    vert.v = v1;
    ta->commit_vertex(&vert, sizeof(vert));
}

void draw_string(float x, float y, float z, float a, float r, float g, float b, char *str, float xs, float ys) {
  poly_hdr_t poly;
  ta->poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB4444_TWID, 512, 512,
		   font_tex, TA_BILINEAR_FILTER);
  ta->commit_poly_hdr(&poly);
  
  while (*str) {
    draw_char(x, y, z, a, r, g, b, *str++, xs, ys);
	x+=32*xs;
  }
}

int sinus_offset = 0;

void sinus_text(float x, float y, float z, float a, float r, float g, float b, char *str, float xs, float ys) {
  poly_hdr_t poly;
  
  ta->poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB4444_TWID, 512, 512,
		   font_tex, TA_BILINEAR_FILTER);
  ta->commit_poly_hdr(&poly);
  
  while ((*str) && (x < 640.0)) {
    draw_char(x, y + SIN((int)((x + sinus_offset) * 2))*10, z, a, r, g, b, *str++, xs, ys);
    x+=32*xs;
    sinus_offset = sinus_offset + 1;
  }
}

