#ifndef __MISC_H__
#define __MISC_H__

#define BACK_FILE  "background.jpg" 
#define TITLE_FILE "title.jpg"
#define FONT_FILE  "font.bin"
#define STAR_FILE  "star.bin"
#define BR1_FILE   "br1.jpg"
#define BR2_FILE   "br2.jpg"
#define BR3_FILE   "br3.jpg"
#define BR4_FILE   "br4.jpg"
#define S3M_FILE   "darkness.s3m"
#define NPM_FILE   "napalm.jpg"

#include <stdio.h>
#include <malloc.h>
#include <kallisti/libk.h>
#include <kallisti/abi/ta.h>
#include <kallisti/abi/fs.h>
#include <kallisti/abi/maple.h>
#include <kallisti/abi/thread.h>
#include <kallisti/abi/spu.h>

#include "matrix.h"
#include "sincos.h"
#include "sqrt.h"
#include "memcpyskip.h"
#include "font.h"
#include "static.h"
#include "inter.h"
#include "fire.h"
#include "plasma.h"
#include "stars.h"
#include "special.h"
#include "cube.h"
#include "title.h"
#include "3d.h"
#include "particle.h"
#include "beetle.h"
#include "loadbin.h"
#include "loadjpeg.h"
#include "rotozoom.h"
#include "shiver.h"
#include "pvrutils.h"

extern char *credits[];
extern char scrolltext[];

extern abi_ta_t	*ta;
extern abi_fs_t	*fs;
extern abi_maple_t *maple;
extern abi_thread_t *thread;
extern abi_spu_t *spu;

extern unsigned int inter_tex;
extern unsigned int fire_tex;
extern unsigned int stars_tex;
extern unsigned int plasma_tex;
extern unsigned int special_tex;
extern unsigned int static_tex;
extern unsigned int font_tex;
extern unsigned int title_tex;
extern unsigned int particle_tex;
extern unsigned int br1_tex;
extern unsigned int br2_tex;
extern unsigned int br3_tex;
extern unsigned int br4_tex;
extern unsigned int y2k_tex;
extern unsigned int zoom512;
extern unsigned int zoom256;
extern unsigned int zoom128;
extern unsigned int zoom64;

int sprintf(char *buf, const char *fmt, ...);
int rand();
int randnum(int limit);
void* calloc(int size);
#endif
